> ## Documentation Index
> Fetch the complete documentation index at: https://getconvoy.io/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a subscription

> This endpoint creates a subscriptions



## OpenAPI

````yaml post /v1/projects/{projectID}/subscriptions
openapi: 3.0.0
info:
  contact:
    email: support@getconvoy.io
    name: Convoy Support
    url: https://getconvoy.io/docs
  description: >-
    Convoy is a fast and secure webhooks proxy. This document contains
    datastore.s API specification.
  license:
    name: Mozilla Public License 2.0
    url: https://www.mozilla.org/en-US/MPL/2.0/
  termsOfService: https://getconvoy.io/terms
  title: Convoy API Reference
  version: 24.1.4
servers:
  - url: https://us.getconvoy.cloud/api
    description: US Region
  - url: https://eu.getconvoy.cloud/api
    description: EU Region
security: []
tags:
  - description: Subscription related APIs
    name: Subscriptions
  - description: Endpoint related APIs
    name: Endpoints
  - description: Event related APIs
    name: Events
  - description: Source related APIs
    name: Sources
  - description: EventDelivery related APIs
    name: Event Deliveries
  - description: Delivery Attempt related APIs
    name: Delivery Attempts
  - description: Portal Links related APIs
    name: Portal Links
  - description: Meta Events related APIs
    name: Meta Events
  - description: Event Types related APIs
    name: EventTypes
  - description: Filters related APIs
    name: Filters
  - description: Onboard related APIs
    name: Onboard
paths:
  /v1/projects/{projectID}/subscriptions:
    post:
      tags:
        - Subscriptions
      summary: Create a subscription
      description: This endpoint creates a subscriptions
      operationId: CreateSubscription
      parameters:
        - description: Project ID
          in: path
          name: projectID
          required: true
          schema:
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/models.CreateSubscription'
        description: Subscription details
        required: true
      responses:
        '201':
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/util.ServerResponse'
                  - properties:
                      data:
                        $ref: '#/components/schemas/models.SubscriptionResponse'
                    type: object
          description: Created
        '400':
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/util.ServerResponse'
                  - properties:
                      data:
                        $ref: '#/components/schemas/handlers.Stub'
                    type: object
          description: Bad Request
        '401':
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/util.ServerResponse'
                  - properties:
                      data:
                        $ref: '#/components/schemas/handlers.Stub'
                    type: object
          description: Unauthorized
        '404':
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/util.ServerResponse'
                  - properties:
                      data:
                        $ref: '#/components/schemas/handlers.Stub'
                    type: object
          description: Not Found
      security:
        - ApiKeyAuth: []
components:
  schemas:
    models.CreateSubscription:
      properties:
        alert_config:
          allOf:
            - $ref: '#/components/schemas/models.AlertConfiguration'
          description: Alert configuration
        app_id:
          description: Deprecated but necessary for backward compatibility
          type: string
        delivery_mode:
          allOf:
            - $ref: '#/components/schemas/datastore.DeliveryMode'
          description: Delivery mode configuration
        endpoint_id:
          description: Destination endpoint ID
          type: string
        filter_config:
          allOf:
            - $ref: '#/components/schemas/models.FilterConfiguration'
          description: Filter configuration
        function:
          description: >-
            Convoy supports mutating your request payload using a js function.
            Use this field

            to specify a `transform` function for this purpose. See
            this[https://docs.getconvoy.io/product-manual/subscriptions#functions]
            for more
          type: string
        name:
          description: Subscription Nme
          type: string
        rate_limit_config:
          allOf:
            - $ref: '#/components/schemas/models.RateLimitConfiguration'
          description: Rate limit configuration
        source_id:
          description: Source Id
          type: string
      type: object
    util.ServerResponse:
      properties:
        message:
          type: string
        status:
          type: boolean
      type: object
    models.SubscriptionResponse:
      properties:
        alert_config:
          allOf:
            - $ref: '#/components/schemas/datastore.AlertConfiguration'
          description: subscription config
        created_at:
          type: string
        deleted_at:
          type: string
        delivery_mode:
          $ref: '#/components/schemas/datastore.DeliveryMode'
        device_metadata:
          $ref: '#/components/schemas/datastore.Device'
        endpoint_metadata:
          $ref: '#/components/schemas/datastore.Endpoint'
        filter_config:
          $ref: '#/components/schemas/datastore.FilterConfiguration'
        function:
          type: string
        name:
          type: string
        project_id:
          type: string
        rate_limit_config:
          $ref: '#/components/schemas/datastore.RateLimitConfiguration'
        retry_config:
          $ref: '#/components/schemas/datastore.RetryConfiguration'
        source_metadata:
          $ref: '#/components/schemas/datastore.Source'
        type:
          $ref: '#/components/schemas/datastore.SubscriptionType'
        uid:
          type: string
        updated_at:
          type: string
      type: object
    handlers.Stub:
      type: object
    models.AlertConfiguration:
      properties:
        count:
          description: Count
          type: integer
        threshold:
          description: Threshold
          type: string
      type: object
    datastore.DeliveryMode:
      enum:
        - at_least_once
        - at_most_once
      type: string
      x-enum-varnames:
        - AtLeastOnceDeliveryMode
        - AtMostOnceDeliveryMode
    models.FilterConfiguration:
      properties:
        event_types:
          description: List of event types that the subscription should match
          items:
            type: string
          type: array
        filter:
          allOf:
            - $ref: '#/components/schemas/models.FS'
          description: Body & Header filters
      type: object
    models.RateLimitConfiguration:
      properties:
        count:
          type: integer
        duration:
          type: integer
      type: object
    datastore.AlertConfiguration:
      properties:
        count:
          type: integer
        threshold:
          type: string
      type: object
    datastore.Device:
      properties:
        created_at:
          type: string
        deleted_at:
          type: string
        endpoint_id:
          type: string
        host_name:
          type: string
        last_seen_at:
          type: string
        project_id:
          type: string
        status:
          $ref: '#/components/schemas/datastore.DeviceStatus'
        uid:
          type: string
        updated_at:
          type: string
      type: object
    datastore.Endpoint:
      properties:
        advanced_signatures:
          type: boolean
        authentication:
          $ref: '#/components/schemas/datastore.EndpointAuthentication'
        content_type:
          type: string
        created_at:
          type: string
        deleted_at:
          type: string
        description:
          type: string
        events:
          type: integer
        failure_rate:
          type: number
        http_timeout:
          type: integer
        mtls_client_cert:
          allOf:
            - $ref: '#/components/schemas/datastore.MtlsClientCert'
          description: mTLS client certificate configuration
        name:
          type: string
        owner_id:
          type: string
        project_id:
          type: string
        rate_limit:
          type: integer
        rate_limit_duration:
          type: integer
        secrets:
          items:
            $ref: '#/components/schemas/datastore.Secret'
          type: array
        slack_webhook_url:
          type: string
        status:
          $ref: '#/components/schemas/datastore.EndpointStatus'
        support_email:
          type: string
        uid:
          type: string
        updated_at:
          type: string
        url:
          type: string
      type: object
    datastore.FilterConfiguration:
      properties:
        event_types:
          items:
            type: string
          type: array
        filter:
          $ref: '#/components/schemas/datastore.FilterSchema'
      type: object
    datastore.RateLimitConfiguration:
      properties:
        count:
          type: integer
        duration:
          type: integer
      type: object
    datastore.RetryConfiguration:
      properties:
        duration:
          type: integer
        retry_count:
          type: integer
        type:
          $ref: '#/components/schemas/datastore.StrategyProvider'
      type: object
    datastore.Source:
      properties:
        body_function:
          type: string
        created_at:
          type: string
        custom_response:
          $ref: '#/components/schemas/datastore.CustomResponse'
        deleted_at:
          type: string
        forward_headers:
          items:
            type: string
          type: array
        header_function:
          type: string
        idempotency_keys:
          items:
            type: string
          type: array
        is_disabled:
          type: boolean
        mask_id:
          type: string
        name:
          type: string
        project_id:
          type: string
        provider:
          $ref: '#/components/schemas/datastore.SourceProvider'
        provider_config:
          $ref: '#/components/schemas/datastore.ProviderConfig'
        pub_sub:
          $ref: '#/components/schemas/datastore.PubSubConfig'
        type:
          $ref: '#/components/schemas/datastore.SourceType'
        uid:
          type: string
        updated_at:
          type: string
        url:
          type: string
        verifier:
          $ref: '#/components/schemas/datastore.VerifierConfig'
      type: object
    datastore.SubscriptionType:
      enum:
        - cli
        - api
      type: string
      x-enum-varnames:
        - SubscriptionTypeCLI
        - SubscriptionTypeAPI
    models.FS:
      properties:
        body:
          $ref: '#/components/schemas/datastore.M'
        headers:
          $ref: '#/components/schemas/datastore.M'
      type: object
    datastore.DeviceStatus:
      enum:
        - offline
        - online
        - disabled
      type: string
      x-enum-varnames:
        - DeviceStatusOffline
        - DeviceStatusOnline
        - DeviceStatusDisabled
    datastore.EndpointAuthentication:
      properties:
        api_key:
          $ref: '#/components/schemas/datastore.ApiKey'
        basic_auth:
          $ref: '#/components/schemas/datastore.BasicAuth'
        oauth2:
          $ref: '#/components/schemas/datastore.OAuth2'
        type:
          $ref: '#/components/schemas/datastore.EndpointAuthenticationType'
      type: object
    datastore.MtlsClientCert:
      properties:
        client_cert:
          description: ClientCert is the client certificate PEM string
          type: string
        client_key:
          description: ClientKey is the client private key PEM string
          type: string
      type: object
    datastore.Secret:
      properties:
        created_at:
          type: string
        deleted_at:
          type: string
        expires_at:
          type: string
        uid:
          type: string
        updated_at:
          type: string
        value:
          type: string
      type: object
    datastore.EndpointStatus:
      enum:
        - active
        - inactive
        - paused
      type: string
      x-enum-varnames:
        - ActiveEndpointStatus
        - InactiveEndpointStatus
        - PausedEndpointStatus
    datastore.FilterSchema:
      properties:
        body:
          $ref: '#/components/schemas/datastore.M'
        headers:
          $ref: '#/components/schemas/datastore.M'
        is_flattened:
          type: boolean
      type: object
    datastore.StrategyProvider:
      enum:
        - linear
        - exponential
      type: string
      x-enum-varnames:
        - LinearStrategyProvider
        - ExponentialStrategyProvider
    datastore.CustomResponse:
      properties:
        body:
          type: string
        content_type:
          type: string
      type: object
    datastore.SourceProvider:
      enum:
        - github
        - twitter
        - shopify
      type: string
      x-enum-varnames:
        - GithubSourceProvider
        - TwitterSourceProvider
        - ShopifySourceProvider
    datastore.ProviderConfig:
      properties:
        twitter:
          $ref: '#/components/schemas/datastore.TwitterProviderConfig'
      type: object
    datastore.PubSubConfig:
      properties:
        amqp:
          $ref: '#/components/schemas/datastore.AmqpPubSubConfig'
        google:
          $ref: '#/components/schemas/datastore.GooglePubSubConfig'
        kafka:
          $ref: '#/components/schemas/datastore.KafkaPubSubConfig'
        sqs:
          $ref: '#/components/schemas/datastore.SQSPubSubConfig'
        type:
          $ref: '#/components/schemas/datastore.PubSubType'
        workers:
          type: integer
      type: object
    datastore.SourceType:
      enum:
        - http
        - rest_api
        - pub_sub
        - db_change_stream
      type: string
      x-enum-varnames:
        - HTTPSource
        - RestApiSource
        - PubSubSource
        - DBChangeStream
    datastore.VerifierConfig:
      properties:
        api_key:
          $ref: '#/components/schemas/datastore.ApiKey'
        basic_auth:
          $ref: '#/components/schemas/datastore.BasicAuth'
        hmac:
          $ref: '#/components/schemas/datastore.HMac'
        type:
          $ref: '#/components/schemas/datastore.VerifierType'
      type: object
    datastore.M:
      additionalProperties: true
      type: object
    datastore.ApiKey:
      properties:
        header_name:
          type: string
        header_value:
          type: string
      type: object
    datastore.BasicAuth:
      properties:
        password:
          type: string
        username:
          type: string
      type: object
    datastore.OAuth2:
      properties:
        audience:
          type: string
        authentication_type:
          $ref: '#/components/schemas/datastore.OAuth2AuthenticationType'
        client_id:
          type: string
        client_secret:
          description: Encrypted at rest
          type: string
        expiry_time_unit:
          allOf:
            - $ref: '#/components/schemas/datastore.OAuth2ExpiryTimeUnit'
          description: Expiry time unit (seconds, milliseconds, minutes, hours)
        field_mapping:
          allOf:
            - $ref: '#/components/schemas/datastore.OAuth2FieldMapping'
          description: Field mapping for flexible token response parsing
        grant_type:
          type: string
        issuer:
          type: string
        scope:
          type: string
        signing_algorithm:
          type: string
        signing_key:
          allOf:
            - $ref: '#/components/schemas/datastore.OAuth2SigningKey'
          description: Encrypted at rest
        subject:
          type: string
        url:
          type: string
      type: object
    datastore.EndpointAuthenticationType:
      enum:
        - api_key
        - oauth2
        - basic_auth
      type: string
      x-enum-varnames:
        - APIKeyAuthentication
        - OAuth2Authentication
        - BasicAuthentication
    datastore.TwitterProviderConfig:
      properties:
        crc_verified_at:
          type: string
      type: object
    datastore.AmqpPubSubConfig:
      properties:
        host:
          type: string
        auth:
          $ref: '#/components/schemas/datastore.AmqpCredentials'
        bindedExchange:
          type: string
        deadLetterExchange:
          type: string
        port:
          type: string
        queue:
          type: string
        routingKey:
          type: string
        schema:
          type: string
        vhost:
          type: string
      type: object
    datastore.GooglePubSubConfig:
      properties:
        project_id:
          type: string
        service_account:
          items:
            type: integer
          type: array
        subscription_id:
          type: string
      type: object
    datastore.KafkaPubSubConfig:
      properties:
        auth:
          $ref: '#/components/schemas/datastore.KafkaAuth'
        brokers:
          items:
            type: string
          type: array
        consumer_group_id:
          type: string
        topic_name:
          type: string
      type: object
    datastore.SQSPubSubConfig:
      properties:
        access_key_id:
          type: string
        default_region:
          type: string
        endpoint:
          description: 'Optional: for LocalStack testing'
          type: string
        queue_name:
          type: string
        secret_key:
          type: string
      type: object
    datastore.PubSubType:
      enum:
        - sqs
        - google
        - kafka
        - amqp
      type: string
      x-enum-varnames:
        - SqsPubSub
        - GooglePubSub
        - KafkaPubSub
        - AmqpPubSub
    datastore.HMac:
      properties:
        encoding:
          $ref: '#/components/schemas/datastore.EncodingType'
        hash:
          type: string
        header:
          type: string
        secret:
          type: string
      type: object
    datastore.VerifierType:
      enum:
        - noop
        - hmac
        - basic_auth
        - api_key
      type: string
      x-enum-varnames:
        - NoopVerifier
        - HMacVerifier
        - BasicAuthVerifier
        - APIKeyVerifier
    datastore.OAuth2AuthenticationType:
      enum:
        - shared_secret
        - client_assertion
      type: string
      x-enum-varnames:
        - SharedSecretAuth
        - ClientAssertionAuth
    datastore.OAuth2ExpiryTimeUnit:
      enum:
        - seconds
        - milliseconds
        - minutes
        - hours
      type: string
      x-enum-varnames:
        - ExpiryTimeUnitSeconds
        - ExpiryTimeUnitMilliseconds
        - ExpiryTimeUnitMinutes
        - ExpiryTimeUnitHours
    datastore.OAuth2FieldMapping:
      properties:
        access_token:
          description: >-
            Field name for access token (e.g., "accessToken", "access_token",
            "token")
          type: string
        expires_in:
          description: >-
            Field name for expiry time (e.g., "expiresIn", "expires_in",
            "expiresAt")
          type: string
        token_type:
          description: Field name for token type (e.g., "tokenType", "token_type")
          type: string
      type: object
    datastore.OAuth2SigningKey:
      properties:
        crv:
          description: EC (Elliptic Curve) key fields
          type: string
        d:
          description: Private key (EC only)
          type: string
        dp:
          description: RSA first factor CRT exponent (RSA private key only)
          type: string
        dq:
          description: RSA second factor CRT exponent (RSA private key only)
          type: string
        e:
          description: RSA public exponent (RSA only)
          type: string
        kid:
          description: Key ID
          type: string
        kty:
          description: 'Key type: "EC" or "RSA"'
          type: string
        'n':
          description: RSA key fields
          type: string
        p:
          description: RSA first prime factor (RSA private key only)
          type: string
        q:
          description: RSA second prime factor (RSA private key only)
          type: string
        qi:
          description: RSA first CRT coefficient (RSA private key only)
          type: string
        x:
          description: X coordinate (EC only)
          type: string
        'y':
          description: Y coordinate (EC only)
          type: string
      type: object
    datastore.AmqpCredentials:
      properties:
        password:
          type: string
        user:
          type: string
      type: object
    datastore.KafkaAuth:
      properties:
        hash:
          type: string
        password:
          type: string
        tls:
          type: boolean
        type:
          type: string
        username:
          type: string
      type: object
    datastore.EncodingType:
      enum:
        - base64
        - hex
      type: string
      x-enum-varnames:
        - Base64Encoding
        - HexEncoding
  securitySchemes:
    ApiKeyAuth:
      in: header
      name: Authorization
      type: apiKey

````